clear all;
close all;

load('heart.dat');
[m n] = size(heart);


yorig = heart(:,n);

% Gera as sadas (rede com dois neurnios na sada)
% Um neurnio por classe
y(1:m,1:2) = 0;
for i=1:m
    if (yorig(i) == 1)
        y(i,:) = [1 0];
    else
        y(i,:) = [0 1];
    end
end

x = heart(:,1:n-1);
% Normaliza as entradas entre [-1,1]
for i=1:n-1
    xmin = min(x(:,i));
    xmax = max(x(:,i));
    for j=1:m
        x(j,i) = 2*((x(j,i) - xmin)/(xmax-xmin))-1;
    end
end

%Divide os pontos em 80% treinamento - 20% teste
num_train_points = round(m*0.8);
xt = x(1:num_train_points,:);
yt = y(1:num_train_points,:);
xv = x(num_train_points+1:end,:);
yv = y(num_train_points+1:end,:);
yv_orig = yorig(num_train_points+1:end,:);

%Treina a rede (5 neuronios na camada escondida e 2 neuronios
%  na camada de sada)
% Todos neuronios com funcao de ativacao logistica
net = newff(xt',yt', 10,{'logsig', 'logsig'}); %, 'trainbfg');
net = init(net);
net = train(net,xt',yt');

% Avalia as amostras do conjunto de teste
ys = sim(net,xv');


ys_orig(1:length(ys)) = 0;

% Converte a saida da rede de um vetor bidimensinal
% para uma saida 1 = classe 1 e 2 = classe 2
for i=1:length(ys)
    [aux pos] = max(ys(:,i));
    ys_orig(i) = pos;
end    

VP = 0;
VN = 0;
FP = 0;
FN = 0;

for i = 1:length(ys_orig)
    % verifica VP
    if     (ys_orig(i) == 2) && (yv_orig(i) == 2)
        VP = VP +1;     
    elseif (ys_orig(i) == 2) && (yv_orig(i) == 1)
        FP = FP +1;    
    elseif (ys_orig(i) == 1) && (yv_orig(i)== 1)
        VN = VN +1; 
    elseif (ys_orig(i) == 1) && (yv_orig(i) == 2)
        FN = FN +1;
    end
end

Espeficidade = VN/(VN+FP)

Sensibilidade = VP/(VP+FN)

