clear all;
close all;

x = (0:0.05:10);
y = sin(2*pi*x);
y = y + 0.1*randn(1,length(y));
y = y';

save exe2.mat;

num_lags = 4;
[data] = build_lag_matrix(y,num_lags);

x = data(:,1:num_lags);
y = data(:,num_lags+1);

num_train_points = 60;
xt = x(1:num_train_points,:);
yt = y(1:num_train_points,:);

xv = x(num_train_points+1:end,:);
yv = y(num_train_points+1:end,:);
num_val_points = length(yv);

net = newff(xt',yt', 3,{'tansig', 'purelin'}, 'trainlm');
net = init(net);
net = train(net,xt',yt');
ys = sim(net,xv');

figure;
plot(yv,'r-');
hold on;
plot(ys,'b-');
legend('Desejado','Saida da Rede');
e = yv-ys';


rmse = sqrt((1/num_val_points)*sum(e.^2));
figure;
plot(e)
hold on;
title(sprintf('Num Atrasoso: %d - RMSE: %d', num_lags, rmse));
